Attribute VB_Name = "mHotkey"
'USAGE:
'Window must be subclassed
'To receive hotkeys, send wParam to analyzing function when msg=WM_HOTKEY
'wParam = id of hotkey (received from RegHotkey)

'WM_HOTKEY& = &H312

Option Explicit

Public Enum HK_Modifier
    MOD_ALT& = &H1
    MOD_CONTROL& = &H2
    MOD_SHIFT& = &H4
    MOD_WIN& = &H8
End Enum

Private Declare Function RegisterHotkey Lib "user32" Alias "RegisterHotKey" (ByVal hwnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Private Declare Function GlobalAddAtom Lib "kernel32" Alias "GlobalAddAtomA" (ByVal lpString As String) As Integer
Private Declare Function GlobalDeleteAtom Lib "kernel32" (ByVal nAtom As Integer) As Integer
Private Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long) As Long


Public Function RegHotkey(hwnd As Long, sID As String, mdf As HK_Modifier, key As Long) As Integer
'hwnd = hwnd of window receiving hotkey
'       msgs must be hooked
'sID  = Hotkey ID (string): Any string
'mdf  = modifier: Ctrl, Shift, Alt, Win
'key  = key: ASCII val
'returns:   integer representing id (long)
'           used to identify hotkey
Dim ret&, iAtom%
iAtom = GlobalAddAtom(id)
ret = RegisterHotkey(hwnd, iAtom, mdf, key)
RegHotkey = iAtom
End Function
Public Sub UnregHotkey(hwnd As Long, id As Integer)
Dim ret&
'removes hotkey, deletes atom
ret = UnregisterHotKey(hwnd, id)
ret = GlobalDeleteAtom(id)
End Sub
